import { Grid } from "./grid.ts";
import { Mouse } from "./input.ts";
import { Painter } from "./painter.ts";
import { Renderer } from "./renderer.ts";

export class Simulator {
    private grid: Grid;

    private myComponent = new Component();

    constructor(
        private mouse: Mouse,
    ) {
        this.grid = new Grid(this.mouse);
    }

    render(r: Renderer) {
        r.clear("black");
        this.grid.render(r, (r) => {
            this.myComponent.render(r);
        });
    }
}

class Circuit {
    private components: Component[] = [];
}

class Component {
    private p = new Painter(64, 64);

    constructor() {
        this.p.clear("black");
    }

    render(r: Renderer) {
        this.p.render(r, 0, 0);
    }
}
